/*
 * PVP.c
 *
 *  Created on: 05.06.2014
 *      Author: FarwickT
 */

#include "PVP.h"
#include "cdefBF609.h"
#include "defBF609.h"
#include "services/int/adi_int.h"
#include <stddef.h>
#include <stdint.h>
#include "GPIO.h"

#define AUTOBUFFERMODE 0x1000
uint8_t *PVPOutBuf1, *PVPOutBuf2;



extern uint8_t IRQ_serviced;

static void PVPPDMAHandler(uint32_t iid, void *pCBParam);

void PVP_init(uint8_t *FrameBuf0, uint8_t *FrameBuf1)
{
	PVPOutBuf1 = FrameBuf0;
	PVPOutBuf2 = FrameBuf1;

	*pREG_VID0_CONN = (BITM_VID_CONN_PVP0IN & (2 << BITP_VID_CONN_PVP0IN));// BITM_VID_CONN_PPI1BCAST |

	*pREG_PVP0_CTL= ENUM_PVP_CTL_CPEN | ENUM_PVP_CTL_PVPEN | ENUM_PVP_CTL_CLKDIV2;

	*pREG_DMA38_XCNT = 752/4u;//360960;
	*pREG_DMA38_XMOD = 4u;
	*pREG_DMA38_YCNT = 480u;//360960;
	*pREG_DMA38_YMOD = 4u;
	*pREG_DMA38_ADDRSTART = FrameBuf0;

	//*pREG_DMA39_CFG = AUTOBUFFERMODE | ENUM_DMA_CFG_ADDR1D | ENUM_DMA_CFG_XCNT_INT |ENUM_DMA_CFG_MSIZE02 | ENUM_DMA_CFG_PSIZE02 | ENUM_DMA_CFG_WRITE | ENUM_DMA_CFG_SYNC;
	*pREG_DMA38_CFG = ENUM_DMA_CFG_STOP | ENUM_DMA_CFG_ADDR2D | ENUM_DMA_CFG_YCNT_INT |ENUM_DMA_CFG_MSIZE04 | ENUM_DMA_CFG_PSIZE04 | ENUM_DMA_CFG_WRITE | ENUM_DMA_CFG_SYNC;

	adi_int_InstallHandler(111u, PVPPDMAHandler, NULL, true);

	//OPF1													//PEC
	*pREG_PVP0_OPF1_CFG = (BITM_PVP_OPF_CFG_IBLOCK0 & (5u << BITP_PVP_OPF_CFG_IBLOCK0)) | (BITM_PVP_OPF_CFG_IPORT0 & (0 << BITP_PVP_OPF_CFG_IPORT0))  | (BITM_PVP_OPF_CFG_MPIPE & 0);
	*pREG_PVP0_OPF1_CFG |= BITM_PVP_OPF_CFG_START & (1 << BITP_PVP_OPF_CFG_START);
	*pREG_PVP0_OPF1_CTL =  ENUM_PVP_OPF_CTL_OSIZE32 | ENUM_PVP_OPF_CTL_NOQFRMT | ENUM_PVP_OPF_CTL_LOWER16 | ENUM_PVP_OPF_CTL_ISIZE8;// | ENUM_PVP_OPF_CTL_FINISH;

	//PEC												//PMA
	*pREG_PVP0_PEC_CFG = (BITM_PVP_PEC_CFG_IBLOCK0 & (48u << BITP_PVP_PEC_CFG_IBLOCK0)) | (BITM_PVP_PEC_CFG_IPORT0 & (2 << BITP_PVP_PEC_CFG_IPORT0))  | (BITM_PVP_PEC_CFG_MPIPE & 0);
	*pREG_PVP0_PEC_CFG |= BITM_PVP_PEC_CFG_START & (1 << BITP_PVP_PEC_CFG_START);
	*pREG_PVP0_PEC_CTL = ENUM_PVP_PEC_CTL_ENCODEDIFF | ENUM_PVP_PEC_CTL_BIN8 | ENUM_PVP_PEC_CTL_ANGLE | ENUM_PVP_PEC_CTL_DERIV1;
	*pREG_PVP0_PEC_D1TH0=100u;
	*pREG_PVP0_PEC_D1TH1=150u;



	//PMA												//CNV1	and CNV2
	*pREG_PVP0_PMA_CFG = (BITM_PVP_PMA_CFG_IBLOCK0 & (0x14u << BITP_PVP_PMA_CFG_IBLOCK0)) | (BITM_PVP_PMA_CFG_IPORT0 & (0 << BITP_PVP_PMA_CFG_IPORT0))  | (BITM_PVP_PMA_CFG_IBLOCK1 & (0x18u << BITP_PVP_PMA_CFG_IBLOCK1)) | (BITM_PVP_PMA_CFG_IPORT1 & (0 << BITP_PVP_PMA_CFG_IPORT1)) | (BITM_PVP_PMA_CFG_MPIPE & 0);
	*pREG_PVP0_PMA_CFG |= BITM_PVP_PMA_CFG_START & (1 << BITP_PVP_PMA_CFG_START);

	//CMV1												//CNV0
	*pREG_PVP0_CNV1_CFG =(BITM_PVP_CNV_CFG_IBLOCK0 & (0x10u << BITP_PVP_CNV_CFG_IBLOCK0)) | (BITM_PVP_CNV_CFG_IPORT0 & (0 << BITP_PVP_CNV_CFG_IPORT0)) | (BITM_PVP_CNV_CFG_MPIPE & 0);
	*pREG_PVP0_CNV1_CFG |= BITM_PVP_CNV_CFG_START & (1 << BITP_PVP_CNV_CFG_START);
	*pREG_PVP0_CNV1_CTL=(BITM_PVP_CNV_CTL_RFRMT0 & 0) | ENUM_PVP_CNV_CTL_EDGEDUP | ENUM_PVP_CNV_CTL_SIGNEXT;
	*pREG_PVP0_CNV1_C00C01= -(2<<16) | (-1 &0xFFFF);
	*pREG_PVP0_CNV1_C02C03= (2<<16) | 0;
	*pREG_PVP0_CNV1_C04= 1;

	*pREG_PVP0_CNV1_C10C11= -(8<<16) |(-4 &0xFFFF);
	*pREG_PVP0_CNV1_C12C13= (8<<16) | 0;
	*pREG_PVP0_CNV1_C14= 4;

	*pREG_PVP0_CNV1_C20C21= -(12<<16) | (-6 &0xFFFF);
	*pREG_PVP0_CNV1_C22C23= (12<<16) | 0;
	*pREG_PVP0_CNV1_C24= 6;

	*pREG_PVP0_CNV1_C30C31= -(8<<16) | (-4 &0xFFFF);
	*pREG_PVP0_CNV1_C32C33= (8<<16) | 0;
	*pREG_PVP0_CNV1_C34= 4;

	*pREG_PVP0_CNV1_C40C41= -(2<<16) | (-1 &0xFFFF);
	*pREG_PVP0_CNV1_C42C43= (2<<16) | 0;
	*pREG_PVP0_CNV1_C44= 1;

	*pREG_PVP0_CNV1_SCALE=0;


	//CMV2												//CNV0
	*pREG_PVP0_CNV2_CFG =(BITM_PVP_CNV_CFG_IBLOCK0 & (0x10u << BITP_PVP_CNV_CFG_IBLOCK0)) | (BITM_PVP_CNV_CFG_IPORT0 & (0 << BITP_PVP_CNV_CFG_IPORT0)) | (BITM_PVP_CNV_CFG_MPIPE & 0);
	*pREG_PVP0_CNV2_CFG |= BITM_PVP_CNV_CFG_START & (1 << BITP_PVP_CNV_CFG_START);
	*pREG_PVP0_CNV2_CTL= (BITM_PVP_CNV_CTL_RFRMT0 & 0) | ENUM_PVP_CNV_CTL_EDGEDUP | ENUM_PVP_CNV_CTL_SIGNEXT;
	*pREG_PVP0_CNV2_C00C01= (4<<16) | 1;
	*pREG_PVP0_CNV2_C02C03= (4<<16) | 6;
	*pREG_PVP0_CNV2_C04= 1;

	*pREG_PVP0_CNV2_C10C11= (8<<16) | 2;
	*pREG_PVP0_CNV2_C12C13= (8<<16) | 12;
	*pREG_PVP0_CNV2_C14= 2;

	*pREG_PVP0_CNV2_C20C21= (0<<16) | 0;
	*pREG_PVP0_CNV2_C22C23= (0<<16) | 0;
	*pREG_PVP0_CNV2_C24= 0;

	*pREG_PVP0_CNV2_C30C31= -(8<<16) | (-2 &0xFFFF);
	*pREG_PVP0_CNV2_C32C33= -(8<<16) | (-12 &0xFFFF);
	*pREG_PVP0_CNV2_C34= -2;

	*pREG_PVP0_CNV2_C40C41= -(4<<16) | (-1 &0xFFFF);
	*pREG_PVP0_CNV2_C42C43= -(4<<16) | (-6 &0xFFFF);
	*pREG_PVP0_CNV2_C44= -1;

	*pREG_PVP0_CNV2_SCALE=0;


													//IPF0
	*pREG_PVP0_CNV0_CFG =(BITM_PVP_CNV_CFG_IBLOCK0 & (12u << BITP_PVP_CNV_CFG_IBLOCK0)) | (BITM_PVP_CNV_CFG_IPORT0 & (0 << BITP_PVP_CNV_CFG_IPORT0)) | (BITM_PVP_CNV_CFG_MPIPE & 0);
	*pREG_PVP0_CNV0_CFG |= BITM_PVP_CNV_CFG_START & (1 << BITP_PVP_CNV_CFG_START);
	*pREG_PVP0_CNV0_CTL= (BITM_PVP_CNV_CTL_RFRMT0 & 0) | (BITM_PVP_CNV_CTL_SHIFT & (15 << BITP_PVP_CNV_CTL_SHIFT));
	*pREG_PVP0_CNV0_C00C01= (397<<16) | 99;
	*pREG_PVP0_CNV0_C02C03= (397 <<16) | 695;
	*pREG_PVP0_CNV0_C04= 99;

	*pREG_PVP0_CNV0_C10C11= (1986 <<16) |397 ;
	*pREG_PVP0_CNV0_C12C13= (1986 <<16) | 3277;
	*pREG_PVP0_CNV0_C14= 397;

	*pREG_PVP0_CNV0_C20C21= (3277 <<16) | 695;
	*pREG_PVP0_CNV0_C22C23= (3277 <<16) | 5362;
	*pREG_PVP0_CNV0_C24= 695;

	*pREG_PVP0_CNV0_C30C31= (1986 <<16) | 397;
	*pREG_PVP0_CNV0_C32C33= (1986 <<16) | 3277;
	*pREG_PVP0_CNV0_C34= 397;

	*pREG_PVP0_CNV0_C40C41= ( 397 <<16) | 99;
	*pREG_PVP0_CNV0_C42C43= (397 <<16) | 695;
	*pREG_PVP0_CNV0_C44= 99;

	*pREG_PVP0_CNV0_SCALE=0;


	*pREG_PVP0_IPF0_CFG= 0;
	*pREG_PVP0_IPF0_PIPECTL=0;// BITM_PVP_IPF_PIPECTL_DRAIN;
	*pREG_PVP0_IPF0_CTL=  BITM_PVP_IPF_CTL_BFRMT0 | ENUM_PVP_IPF_CTL_NOQFRMT | ENUM_PVP_IPF_CTL_ZEROEXT | ENUM_PVP_IPF_CTL_UNPACKEN | ENUM_PVP_IPF_CTL_Y8 | ENUM_PVP_IPF_CTL_OPORT0EN;
	*pREG_PVP0_IPF0_FCNT=0;
	*pREG_PVP0_IPF0_HCNT=752u;
	*pREG_PVP0_IPF0_VCNT=480u;
	*pREG_PVP0_IPF0_HPOS=0;
	*pREG_PVP0_IPF0_VPOS=0;


	*pREG_DMA38_CFG |= ENUM_DMA_CFG_EN;
	asm("ssync;");
	*pREG_PVP0_IPF0_CFG |= (BITM_PVP_IPF0_CFG_START & (1 << BITP_PVP_IPF0_CFG_START));
	asm("ssync;");
}




#pragma section ("L1_code")
static void PVPPDMAHandler(uint32_t iid, void *pCBParam)
{
	static uint8_t i=0;
	uint32_t dma_stat=0;

	*pREG_SEC0_GCTL&= ~ENUM_SEC_GCTL_EN;
	*pREG_SEC0_CCTL0&= ~ENUM_SEC_CCTL_EN;

	*pREG_DMA38_STAT |= ENUM_DMA_STAT_IRQDONE;

	*pREG_EPPI1_STAT |= ENUM_EPPI_STAT_LTERROVR;


	dma_stat = (*pREG_DMA38_STAT & BITM_DMA_STAT_RUN) >> BITP_DMA_STAT_RUN;
	while(dma_stat != 0u)
	{
		dma_stat = (*pREG_DMA38_STAT & BITM_DMA_STAT_RUN) >> BITP_DMA_STAT_RUN;
	}

	*pREG_EPPI1_CTL &= ~BITM_EPPI_CTL_EN;
	*pREG_DMA38_CFG &= ~ENUM_DMA_CFG_EN;
	asm("ssync;");
	if(i==0)
	{
		*pREG_DMA38_ADDRSTART = PVPOutBuf2;
		i=1;
	}
	else
	{
		*pREG_DMA38_ADDRSTART = PVPOutBuf1;
		i=0;
	}

	IRQ_serviced=1;


	LEDOnOff(false);
	asm("nop;");
}

#pragma section ("L1_code")
void reinit_all(void)
{
	uint32_t PVP_Stat=0, Drain_Stat=0;

	*pREG_DMA38_CFG |= ENUM_DMA_CFG_EN;
	asm("ssync;");

	*pREG_PVP0_OPF1_CFG |= BITM_PVP_OPF_CFG_START & (1 << BITP_PVP_OPF_CFG_START);
	*pREG_PVP0_PEC_CFG |= BITM_PVP_PEC_CFG_START & (1 << BITP_PVP_PEC_CFG_START);
	*pREG_PVP0_PMA_CFG |= BITM_PVP_PMA_CFG_START & (1 << BITP_PVP_PMA_CFG_START);
	*pREG_PVP0_CNV1_CFG |= BITM_PVP_CNV_CFG_START & (1 << BITP_PVP_CNV_CFG_START);
	*pREG_PVP0_CNV2_CFG |= BITM_PVP_CNV_CFG_START & (1 << BITP_PVP_CNV_CFG_START);
	*pREG_PVP0_CNV0_CFG |= BITM_PVP_CNV_CFG_START & (1 << BITP_PVP_CNV_CFG_START);
	*pREG_PVP0_IPF0_CFG |= (BITM_PVP_IPF0_CFG_START & (1 << BITP_PVP_IPF0_CFG_START));
	asm("ssync;");

	PVP_Stat = (*pREG_PVP0_STAT & BITM_PVP_STAT_CPDC) >> BITP_PVP_STAT_CPDC;
	while(PVP_Stat != 0)
	{
		PVP_Stat = (*pREG_PVP0_STAT & BITM_PVP_STAT_CPDC) >> BITP_PVP_STAT_CPDC;
	}
	*pREG_EPPI1_CTL |= ENUM_EPPI_CTL_EN;

	*pREG_SEC0_GCTL=ENUM_SEC_GCTL_EN;
	*pREG_SEC0_CCTL0=ENUM_SEC_CCTL_EN;
}


