/*****************************************************************************
 * bare_metall_ppi_Core0.c
 *****************************************************************************/

#include <ccblkfn.h>
#include "adi_initialize.h"
#include <services/pwr/adi_pwr.h>
#include "bare_metall_ppi_Core0.h"
#include "drivers/twi/adi_twi.h"
#include "Cam_Twi.h"
#include <stdio.h>
#include "ppi.h"
#include "PVP.h"
#include "GPIO.h"


#pragma section ("sdram_bank1_zeroinit",ZERO_INIT)
static uint8_t VideoBuf0[752*480*2];
#pragma section ("sdram_bank1_zeroinit", ZERO_INIT)
static uint8_t VideoBuf1[752*480*2];

#pragma section ("bsz", ZERO_INIT)
uint8_t IRQ_serviced;

extern void ConfigSoftSwitches_BF609(void);



/* External input clock frequency in Hz */
#define PROC_CLOCK_IN                   (25000000u)
/* Maximum core clock frequency in Hz */
#define PROC_MAX_CORE_CLOCK             (500000000u)
/* Maximum system clock frequency in Hz */
#define PROC_MAX_SYS_CLOCK              (300000000u)
/* Minimum VCO clock frequency in Hz */
#define PROC_MIN_VCO_CLOCK              (25000000u)
/* Required core clock frequency in Hz */
#define PROC_REQ_CORE_CLOCK             (500000000u)
/* Required system clock frequency in Hz */
#define PROC_REQ_SYS_CLOCK              (150000000u)



#pragma section ("L1_code")
int main(void)
{


	if (adi_pwr_Init (PROC_CLOCK_IN, PROC_MAX_CORE_CLOCK, PROC_MAX_SYS_CLOCK, PROC_MIN_VCO_CLOCK) != ADI_PWR_SUCCESS)
	{
		printf ("Failed to initialize Power service\n");
	}
	if(adi_pwr_SetFreq(PROC_REQ_CORE_CLOCK, PROC_REQ_SYS_CLOCK)!= ADI_PWR_SUCCESS )
	{
		printf ("Failed to initialize Power service\n");
	}

	adi_initComponents();

	*pREG_SEC0_GCTL=ENUM_SEC_GCTL_EN;
	*pREG_SEC0_CCTL0=ENUM_SEC_CCTL_EN;


	ConfigSoftSwitches_BF609();
	GPIO_init();
	Twi_init_Cam();

	PVP_init(VideoBuf0, VideoBuf1);
	PPI_init(NULL, NULL);

	while(1)
	{
		asm("nop;");
		if(IRQ_serviced == 1)
		{
			reinit_all();
			IRQ_serviced=0;
		}
		asm("nop;");
	}

	/* Begin adding your custom code here */

	return 0;
}

