/*
**
** pvp_cannycamera.c file generated on Juni 12, 2014 at 13:57:53.
**
** Copyright (C) 2000-2014 Analog Devices Inc., All Rights Reserved.
**
** This file is generated automatically based upon the options selected in the PVP Programmer
** configuration editor. Changes to the PVP Programmer configuration should be made
** by changing the appropriate options rather than editing this file.
**
** For descriptions of each parameter, please refer to the PVP Programmer Help.
**
*/

#include <stdio.h>
#include <builtins.h>
#include <drivers/pvp/adi_pvp.h>
#include "pvp_programmer.h"
#include <stddef.h>

#pragma diag(suppress:misra_rule_14_7 : "Functions use multiple return statements to improve code readability.")

/* Macros to enable/disable error messages */
#define REPORT_ERROR(...)

/*
 * Memory required for configuration of modules
 */
static uint8_t      ConfMem[ADI_PVP_CONF_MEM_SIZE];

static uint8_t      IPF0ConfMem[ADI_PVP_IPF_MEM_SIZE];        /* Memory required for IPF module configuration */
static uint8_t      CNV0ConfMem[ADI_PVP_CNV_MEM_SIZE];        /* Memory required for CNV module configuration */
static uint8_t      CNV1ConfMem[ADI_PVP_CNV_MEM_SIZE];        /* Memory required for CNV module configuration */
static uint8_t      CNV2ConfMem[ADI_PVP_CNV_MEM_SIZE];        /* Memory required for CNV module configuration */
static uint8_t      PECConfMem[ADI_PVP_PEC_MEM_SIZE];        /* Memory required for PEC module configuration */
static uint8_t      PMAConfMem[ADI_PVP_PMA_MEM_SIZE];        /* Memory required for PMA module configuration */
static uint8_t      OPF1ConfMem[ADI_PVP_OPF_MEM_SIZE];        /* Memory required for OPF module configuration */


/* configuration handle */
static ADI_PVP_CONFIG_HANDLE    cannycameraConf;




/**
 * Initialize the IPF0 module
 */
static ADI_PVP_RESULT PvpInitcannycameraIPF0Module(void) 
{
    ADI_PVP_RESULT eResult;

    static ADI_PVP_IPF_CONTROL oIPF0Control;
    static ADI_PVP_IPF_PIPE_CONTROL oIPF0PipeControl;
	
    eResult = adi_pvp_ipf_Init(
                cannycameraConf,               /* Configuration handle for the IPF module to be initialized */
                ADI_PVP_MODULE_IPF0,           /* Module ID for the module to be initialized (IPF0) */
                IPF0ConfMem,                   /* Memory for IPF0 configuration */
                ADI_PVP_IPF_MEM_SIZE,          /* Size of the given memory in bytes */
                NULL);                         /* Reference configuration */    

    if(eResult != ADI_PVP_SUCCESS)
    {
        REPORT_ERROR("Failed to initialize IPF0 module [Error: 0x%08X]\n", eResult);
		return eResult;
    }

    oIPF0Control.bOutPort0               =  true;
    oIPF0Control.eOutPort1               =  ADI_PVP_IPF_PORT1_DISABLE;
    oIPF0Control.bOutPort2               =  false;
    oIPF0Control.eColorFormat            =  ADI_PVP_COLOR_FORMAT_YONLY_8BIT;
    oIPF0Control.bEnableUnpack           =  false;
    oIPF0Control.bExtractRed             =  false;
    oIPF0Control.bEnableSignExtn         =  false;
    oIPF0Control.bEnableQFormat          =  false;
    oIPF0Control.bColorExtractionEnable  =  false;
    oIPF0Control.bBayerType              =  true;
    oIPF0Control.bBlueExtraction         =  false;
    	
    eResult = adi_pvp_ipf_SetControlWord(
                cannycameraConf,               /* Configuration handle in which IPF module to be initialized */
                ADI_PVP_MODULE_IPF0,           /* Module ID for the module to be initialized (IPF) */
                &oIPF0Control);                /* Control word to be set */ 
    				
    if( eResult != ADI_PVP_SUCCESS)
    {
        REPORT_ERROR("Failed to set the control word for IPF module 0x%08X\n", eResult);
        return eResult;
    }	

    oIPF0PipeControl.bEnableDrain      =     false;
    oIPF0PipeControl.bEnableStatusDMA  =     false;
    	
    eResult = adi_pvp_ipf_SetPipeControlWord(
                cannycameraConf,               /* Configuration handle in which IPF module to be initialized */
                ADI_PVP_MODULE_IPF0,           /* Module ID for the module to be initialized (IPF) */
                &oIPF0PipeControl);            /* Pointer to the ADI_PVP_IPF_PIPE_CONTROL structure */
    				  
    if( eResult != ADI_PVP_SUCCESS)
    {
        REPORT_ERROR("Failed to set IPF pipe control word 0x%08X\n", eResult);
        return eResult;
    }	

    eResult = adi_pvp_ipf_SetROISize(
                cannycameraConf,               /* Configuration handle in which IPF module to be initialized */
                ADI_PVP_MODULE_IPF0,           /* Module ID for the module to be initialized (IPF) */ 
                752u,                          /* Frame width */           
                480u);                         /* Frame height */  
    				
    if( eResult != ADI_PVP_SUCCESS)
    {
        REPORT_ERROR("Failed to set ROI size 0x%08X\n", eResult);
        return eResult;
    }
	
    return eResult;
}


/**
 * Initialize the CNV0 module
 */
static ADI_PVP_RESULT PvpInitcannycameraCNV0Module(void)
{
	ADI_PVP_RESULT eResult;
    ADI_PVP_CNV_CONTROL oCNV0Control;
    ADI_PVP_CNV_KERNEL gCNV0Coef = { 99,397,695,397,99,397,1986,3277,1986,397,695,3277,5362,3277,695,397,1986,3277,1986,397,99,397,695,397,99 };
	
    eResult = adi_pvp_cnv_Init(
                cannycameraConf,               /* Configuration handle for the CNV module to be initialized */
                ADI_PVP_MODULE_CNV0,           /* Module ID for the module to be initialized (CNV0) */
                CNV0ConfMem,                   /* Memory for CNV0 configuration */
                ADI_PVP_CNV_MEM_SIZE,          /* Size of the given memory in bytes */
                NULL);                         /* Reference configuration */
                  
    if(eResult != ADI_PVP_SUCCESS)
    {
        REPORT_ERROR("Failed to initialize CNV0 module [Error: 0x%08X]\n", eResult);
		return eResult;
    }
	
    oCNV0Control.bSat32               = false;
    oCNV0Control.bZeroFill            = false;
    oCNV0Control.nShift               = 0;
    	
    eResult = adi_pvp_cnv_SetControlWord(
                cannycameraConf,               /* Configuration handle in which CNV module to be initialized */
                ADI_PVP_MODULE_CNV0,           /* Module ID for the module to be initialized (CNV) */
                &oCNV0Control);                /* Control word to be set */
					
    if(eResult != ADI_PVP_SUCCESS)
    {
        REPORT_ERROR("Failed to set CNV0 control word [Error: 0x%08X]\n", eResult);
        return eResult;
    }
	
    eResult = adi_pvp_cnv_SetCoef(
                cannycameraConf,               /* Configuration handle in which CNV module to be initialized */
                ADI_PVP_MODULE_CNV0,           /* Module ID for the module to be initialized (CNV) */
                &gCNV0Coef);                   /* Coefficient matrix */
    if(eResult != ADI_PVP_SUCCESS)
    {
        REPORT_ERROR("Failed to set the coefficients for CNV block [Error: 0x%08X]\n", eResult);
        return eResult;
    }

    return eResult;
}



/**
 * Initialize the CNV1 module
 */
static ADI_PVP_RESULT PvpInitcannycameraCNV1Module(void)
{
	ADI_PVP_RESULT eResult;
    ADI_PVP_CNV_CONTROL oCNV1Control;
    ADI_PVP_CNV_KERNEL gCNV1Coef = { -1,-2,0,2,1,-4,-8,0,8,4,-6,-12,0,12,6,-4,-8,0,8,4,-1,-2,0,2,1 };
	
    eResult = adi_pvp_cnv_Init(
                cannycameraConf,               /* Configuration handle for the CNV module to be initialized */
                ADI_PVP_MODULE_CNV1,           /* Module ID for the module to be initialized (CNV1) */
                CNV1ConfMem,                   /* Memory for CNV1 configuration */
                ADI_PVP_CNV_MEM_SIZE,          /* Size of the given memory in bytes */
                NULL);                         /* Reference configuration */
                  
    if(eResult != ADI_PVP_SUCCESS)
    {
        REPORT_ERROR("Failed to initialize CNV1 module [Error: 0x%08X]\n", eResult);
		return eResult;
    }
	
    oCNV1Control.bSat32               = false;
    oCNV1Control.bZeroFill            = false;
    oCNV1Control.nShift               = 0;
    //oCNV1Control.bRedPixelConvEnable  = $block.redPixelSubstitution;
    //oCNV1Control.bBayerType           = $block.bayerType;
    	
    eResult = adi_pvp_cnv_SetControlWord(
                cannycameraConf,               /* Configuration handle in which CNV module to be initialized */
                ADI_PVP_MODULE_CNV1,           /* Module ID for the module to be initialized (CNV) */
                &oCNV1Control);                /* Control word to be set */
					
    if(eResult != ADI_PVP_SUCCESS)
    {
        REPORT_ERROR("Failed to set CNV1 control word [Error: 0x%08X]\n", eResult);
        return eResult;
    }
	
    eResult = adi_pvp_cnv_SetCoef(
                cannycameraConf,               /* Configuration handle in which CNV module to be initialized */
                ADI_PVP_MODULE_CNV1,           /* Module ID for the module to be initialized (CNV) */
                &gCNV1Coef);                   /* Coefficient matrix */
    if(eResult != ADI_PVP_SUCCESS)
    {
        REPORT_ERROR("Failed to set the coefficients for CNV block [Error: 0x%08X]\n", eResult);
        return eResult;
    }

    return eResult;
}



/**
 * Initialize the CNV2 module
 */
static ADI_PVP_RESULT PvpInitcannycameraCNV2Module(void)
{
	ADI_PVP_RESULT eResult;
    ADI_PVP_CNV_CONTROL oCNV2Control;
    ADI_PVP_CNV_KERNEL gCNV2Coef = { 1,4,6,4,1,2,8,12,8,2,0,0,0,0,0,-2,-8,-12,-8,-2,-1,-4,-6,-4,-1 };
	
    eResult = adi_pvp_cnv_Init(
                cannycameraConf,               /* Configuration handle for the CNV module to be initialized */
                ADI_PVP_MODULE_CNV2,           /* Module ID for the module to be initialized (CNV2) */
                CNV2ConfMem,                   /* Memory for CNV2 configuration */
                ADI_PVP_CNV_MEM_SIZE,          /* Size of the given memory in bytes */
                NULL);                         /* Reference configuration */
                  
    if(eResult != ADI_PVP_SUCCESS)
    {
        REPORT_ERROR("Failed to initialize CNV2 module [Error: 0x%08X]\n", eResult);
		return eResult;
    }
	
    oCNV2Control.bSat32               = false;
    oCNV2Control.bZeroFill            = false;
    oCNV2Control.nShift               = 0;
    	
    eResult = adi_pvp_cnv_SetControlWord(
                cannycameraConf,               /* Configuration handle in which CNV module to be initialized */
                ADI_PVP_MODULE_CNV2,           /* Module ID for the module to be initialized (CNV) */
                &oCNV2Control);                /* Control word to be set */
					
    if(eResult != ADI_PVP_SUCCESS)
    {
        REPORT_ERROR("Failed to set CNV2 control word [Error: 0x%08X]\n", eResult);
        return eResult;
    }
	
    eResult = adi_pvp_cnv_SetCoef(
                cannycameraConf,               /* Configuration handle in which CNV module to be initialized */
                ADI_PVP_MODULE_CNV2,           /* Module ID for the module to be initialized (CNV) */
                &gCNV2Coef);                   /* Coefficient matrix */
    if(eResult != ADI_PVP_SUCCESS)
    {
        REPORT_ERROR("Failed to set the coefficients for CNV block [Error: 0x%08X]\n", eResult);
        return eResult;
    }

    return eResult;
}



/**
 * Initialize the PEC module
 */
static ADI_PVP_RESULT PvpInitcannycameraPECModule(void) 
{
    ADI_PVP_RESULT eResult;
    ADI_PVP_PEC_CONTROL oPECControl;	

    eResult = adi_pvp_pec_Init(
                cannycameraConf,               /* Configuration handle for the PEC module to be initialized */
                ADI_PVP_MODULE_PEC,            /* Module ID for the module to be initialized (PEC) */
                PECConfMem,                    /* Memory for PEC configuration */
                ADI_PVP_PEC_MEM_SIZE,          /* Size of the given memory in bytes */
                NULL);                         /* Reference configuration */    

    if(eResult != ADI_PVP_SUCCESS)
    {
        REPORT_ERROR("Failed to initialize PEC module [Error: 0x%08X]\n", eResult);
		return eResult;
    }

    oPECControl.b2ndDerivative     =    false;
    oPECControl.bZeroCrossing      =    false;
    oPECControl.b16BitsPerBin      =    false;
    oPECControl.bDiffEncoding      =    false;
    	
    eResult = adi_pvp_pec_SetControlWord(
                cannycameraConf,               /* Configuration handle in which PEC module to be initialized */
                ADI_PVP_MODULE_PEC,            /* Module ID for the module to be initialized (PEC) */
                &oPECControl);                 /* Control word to be set */ 
    				
    if( eResult != ADI_PVP_SUCCESS)
    {
        REPORT_ERROR("Failed to set the control word for PEC module 0x%08X\n", eResult);
	    return eResult;
    }

    return eResult;
}

/**
 * Initialize the PMA module
 */
static ADI_PVP_RESULT PvpInitcannycameraPMAModule(void) 
{
    ADI_PVP_RESULT eResult;

    eResult = adi_pvp_pma_Init(
                cannycameraConf,               /* Configuration handle for the PMA module to be initialized */
                ADI_PVP_MODULE_PMA,            /* Module ID for the module to be initialized (PMA) */
                PMAConfMem,                    /* Memory for PMA configuration */
                ADI_PVP_PMA_MEM_SIZE,          /* Size of the given memory in bytes */
                NULL);                         /* Reference configuration */    

    if(eResult != ADI_PVP_SUCCESS)
    {
        REPORT_ERROR("Failed to initialize PMA module [Error: 0x%08X]\n", eResult);
		return eResult;
    }
	
	return eResult;
}


/**
 * Initialize the OPF1 module
 */
static ADI_PVP_RESULT PvpInitcannycameraOPF1Module(void) 
{
    ADI_PVP_RESULT eResult;
    ADI_PVP_OPF_CONTROL oOPF1Control;	

    eResult = adi_pvp_opf_Init(
                cannycameraConf,               /* Configuration handle for the OPF module to be initialized */
                ADI_PVP_MODULE_OPF1,           /* Module ID for the module to be initialized (OPF1) */
                OPF1ConfMem,                   /* Memory for OPF1 configuration */
                ADI_PVP_OPF_MEM_SIZE,          /* Size of the given memory in bytes */
                NULL);                         /* Reference configuration */    

    if(eResult != ADI_PVP_SUCCESS)
    {
        REPORT_ERROR("Failed to initialize OPF1 module [Error: 0x%08X]\n", eResult);
		return eResult;
    }
	
    oOPF1Control.eInDataWidth     =   ADI_PVP_OPF_IN_DATA_8BIT;
    oOPF1Control.eOutDataWidth    =   ADI_PVP_OPF_OUT_DATA_32BIT;
    oOPF1Control.bUseUpper16bits  =   false;
    oOPF1Control.bChangeSign      =   false;
    oOPF1Control.bFinishSignal    =   true;
    
    eResult = adi_pvp_opf_SetControlWord(
                cannycameraConf,               /* Configuration handle in which OPF module to be initialized */
                ADI_PVP_MODULE_OPF1,           /* Module ID for the module to be initialized (OPF) */
                &oOPF1Control);                /* Control word to be set */  
    				
    if( eResult != ADI_PVP_SUCCESS)
    {
        REPORT_ERROR("Failed to set OPF control word 0x%08X\n", eResult);
	    return eResult;
    }

	return eResult;
}


/* Create a configuration block that initializes the PVP according to the cannycamera diagram */
ADI_PVP_RESULT PvpCreatecannycameraConfig(ADI_PVP_PIPE_HANDLE hPipe)
{
    ADI_PVP_RESULT eResult;

    eResult = adi_pvp_CreatePipeConfig (
                  hPipe,                         /* Pipe handle for which configuration to be created */
                  ConfMem,                       /* Memory for the configuration */
                  ADI_PVP_CONF_MEM_SIZE,         /* Size of the given memory in bytes */
                  &cannycameraConf               /* Pointer to the configuration handle */
                  
				  );
				  
    if(eResult != ADI_PVP_SUCCESS)
    {
        REPORT_ERROR("Failed to create the configuration 0x%08X\n", eResult);
        return eResult;
    }
	
    if ( PvpInitcannycameraIPF0Module() != ADI_PVP_SUCCESS)
    {
	    REPORT_ERROR("Failed to initialize the configuration 0x%08X\n", eResult);
        return eResult;
    }

    if ( PvpInitcannycameraCNV0Module() != ADI_PVP_SUCCESS)
    {
	    REPORT_ERROR("Failed to initialize the configuration 0x%08X\n", eResult);
        return eResult;
    }

    if ( PvpInitcannycameraCNV1Module() != ADI_PVP_SUCCESS)
    {
	    REPORT_ERROR("Failed to initialize the configuration 0x%08X\n", eResult);
        return eResult;
    }

    if ( PvpInitcannycameraCNV2Module() != ADI_PVP_SUCCESS)
    {
	    REPORT_ERROR("Failed to initialize the configuration 0x%08X\n", eResult);
        return eResult;
    }

    if ( PvpInitcannycameraPECModule() != ADI_PVP_SUCCESS)
    {
	    REPORT_ERROR("Failed to initialize the configuration 0x%08X\n", eResult);
        return eResult;
    }

    if ( PvpInitcannycameraPMAModule() != ADI_PVP_SUCCESS)
    {
	    REPORT_ERROR("Failed to initialize the configuration 0x%08X\n", eResult);
        return eResult;
    }

    if ( PvpInitcannycameraOPF1Module() != ADI_PVP_SUCCESS)
    {
	    REPORT_ERROR("Failed to initialize the configuration 0x%08X\n", eResult);
        return eResult;
    }

    eResult = adi_pvp_ConnectModule (
                  cannycameraConf,               /* Configuration handle */
                  ADI_PVP_MODULE_CNV0,           /* Destination module */
                  0u,                            /* Destination port number */
                  ADI_PVP_MODULE_IPF0,           /* Source module */
                  0u                             /* Source port number */
                  );
    				  
    if(eResult != ADI_PVP_SUCCESS)
    {
        REPORT_ERROR("Failed to connect IPF0 and CNV0 modules 0x%08X\n", eResult);
        return eResult;
    }

    eResult = adi_pvp_ConnectModule (
                  cannycameraConf,               /* Configuration handle */
                  ADI_PVP_MODULE_CNV1,           /* Destination module */
                  0u,                            /* Destination port number */
                  ADI_PVP_MODULE_CNV0,           /* Source module */
                  0u                             /* Source port number */
                  );
    				  
    if(eResult != ADI_PVP_SUCCESS)
    {
        REPORT_ERROR("Failed to connect CNV0 and CNV1 modules 0x%08X\n", eResult);
        return eResult;
    }

    eResult = adi_pvp_ConnectModule (
                  cannycameraConf,               /* Configuration handle */
                  ADI_PVP_MODULE_CNV2,           /* Destination module */
                  0u,                            /* Destination port number */
                  ADI_PVP_MODULE_CNV0,           /* Source module */
                  0u                             /* Source port number */
                  );
    				  
    if(eResult != ADI_PVP_SUCCESS)
    {
        REPORT_ERROR("Failed to connect CNV0 and CNV2 modules 0x%08X\n", eResult);
        return eResult;
    }

    eResult = adi_pvp_ConnectModule (
                  cannycameraConf,               /* Configuration handle */
                  ADI_PVP_MODULE_PMA,            /* Destination module */
                  1u,                            /* Destination port number */
                  ADI_PVP_MODULE_CNV2,           /* Source module */
                  0u                             /* Source port number */
                  );
    				  
    if(eResult != ADI_PVP_SUCCESS)
    {
        REPORT_ERROR("Failed to connect CNV2 and PMA modules 0x%08X\n", eResult);
        return eResult;
    }

    eResult = adi_pvp_ConnectModule (
                  cannycameraConf,               /* Configuration handle */
                  ADI_PVP_MODULE_PMA,            /* Destination module */
                  0u,                            /* Destination port number */
                  ADI_PVP_MODULE_CNV1,           /* Source module */
                  0u                             /* Source port number */
                  );
    				  
    if(eResult != ADI_PVP_SUCCESS)
    {
        REPORT_ERROR("Failed to connect CNV1 and PMA modules 0x%08X\n", eResult);
        return eResult;
    }

    eResult = adi_pvp_ConnectModule (
                  cannycameraConf,               /* Configuration handle */
                  ADI_PVP_MODULE_PEC,            /* Destination module */
                  0u,                            /* Destination port number */
                  ADI_PVP_MODULE_PMA,            /* Source module */
                  2u                             /* Source port number */
                  );
    				  
    if(eResult != ADI_PVP_SUCCESS)
    {
        REPORT_ERROR("Failed to connect PMA and PEC modules 0x%08X\n", eResult);
        return eResult;
    }

    eResult = adi_pvp_ConnectModule (
                  cannycameraConf,               /* Configuration handle */
                  ADI_PVP_MODULE_OPF1,           /* Destination module */
                  0u,                            /* Destination port number */
                  ADI_PVP_MODULE_PEC,            /* Source module */
                  0u                             /* Source port number */
                  );
    				  
    if(eResult != ADI_PVP_SUCCESS)
    {
        REPORT_ERROR("Failed to connect PEC and OPF1 modules 0x%08X\n", eResult);
        return eResult;
    }


    return eResult;
}

/* Return the handle for the cannycamera configuration for use in calls to the lower level PVP driver API */
ADI_PVP_CONFIG_HANDLE PvpGetcannycameraConfigHandle(void)
{
    return cannycameraConf;
}

